<?php
// Redirect to pictory start page
function redirectToPictory($revPiSessionId)
{
   header('Location: /pictory/index.html?hn=' . $revPiSessionId);
   echo "redirect ...";
   exit;
}

session_start();

// Check if already logged in
if (isset($_SESSION["sso_logged_in"]) && $_SESSION["sso_logged_in"] === true) {
   redirectToPictory($_SESSION['RevPiSessionId']);
   exit;
}

if (!isset($_GET['sso_token'])) {
   http_response_code(401);
   echo "No SSO token provided";
   exit;
}

$sso_token = $_GET['sso_token'];
$sso_token_directory = "/run/cockpit-revpi-pictory-sso";
$sso_file_path = $sso_token_directory . "/" . $sso_token;

// Check if sso file exists
if (!file_exists($sso_file_path)) {
   http_response_code(401);
   echo "No SSO file found for token " . $sso_token;
   exit;
}

// Read content of the file
$content = file_get_contents($sso_file_path);
$content_array = explode("\n", $content); // split string by newline
$username = $content_array[0]; // the first and currently only line is the username

// Webstatus login session stored the MD5 of the PHP SessionId
$revPiSessionId = md5(session_id());
// And the JS would then use this hash to set a cookie with this name
// In webstatus the value of the cookie is a incorrectly implemented JWT Token which is actually never read
setcookie('KUNBUS_RevPiSessionId_' . $revPiSessionId, $revPiSessionId, 0, '/');
// pictory ignores the actual value completelly and only checks if this id was stored in the session
$_SESSION['RevPiSessionId'] = $revPiSessionId;

// Mark session as authenticated via SSO
$_SESSION["sso_logged_in"] = true;
$_SESSION["username"] = $username;

// Set SSO cookie to let PiCtory know that it has been started from within cockpit
setcookie('Cockpit_SSO_Host', 'cockpit_sso_host', 0, '/');

// delete the token after session was created
unlink($sso_file_path);

redirectToPictory($revPiSessionId);


?>
